
import java.net.*;
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.applet.*; 



////////////////////////////////////////////////////////////////////////////#
//  
//   File: ClientPanel.java 
//
//      Title  : CPS606 spring98 Final Project, Writing a Java Chat
//      Author: Haci Ali Mantar
//      Contact: hamantar@top.cis.syr.edu
//      Input: Message from User
//       
// Any user can connect to the Chat from anywhere, If the chat is not
// started then user can start autmatically. The server is not running
// all the time. It runs when a user attempt to connect.
// The server runs when start the chat.   
//
//       
//////////////////////////////////////////////////////////////////////////////
//
//  IMPLEMENTATION
//
//////////////////////////////////////////////////////////////////////////////


class server
{
  static DataOutputStream []dos_list = new DataOutputStream[500];// specify the number of user
  static int counter=0;
  static int nconnected=0;

  
  //////////////////////////////////////////////////////////////////////
  /// Initialize the variable and the methods//////////////////////////
  ////////////////////////////////////////////////////////////////////

public static void main(String args[])
  {
          Socket []socket_list = new Socket [500];// There is a socket for each clients. 
          DataInputStream []dis_list = new DataInputStream[500];
 
          InputStream in = null;

          OutputStream out=null; 
          ServerSocket ssock=null;// The server socket which listens the clients
 
          DataInputStream din= null;
          DataOutputStream dos=null;
	  boolean flag=true;
    
      try{
          ssock = new ServerSocket(2311);
          ssock.setSoTimeout(1);//Server check this port every one milisecond.
          }catch(IOException e){
	    ;
           }

	  //////////////////////////////////////////////////////////////////
	  ///This is actually a infine loop. The server stop every//////////
	  /// one ms and come back//////////////////////////////////////////
	  /////////////////////////////////////////////////////////////////    


    while(flag)
      {
        try{
          Socket s = ssock.accept();
          in = s.getInputStream();
          out = s.getOutputStream();
          din = new DataInputStream(in);
          dos = new DataOutputStream(out);
          
          socket_list[counter] = s;
          dis_list[counter]  = din;
          dos_list[counter++]   =dos;
          nconnected++;
          System.out.println("a client is connected ");
        
       }catch(InterruptedIOException e){
          ;
        }catch(IOException e){

          ;
        } 
	////////////////////////////////////////////////////////////////////
	////////Check all the clients whether they have message or not/////
	//////////////////////////////////////////////////////////////////
        
	for(int k=0;k<counter;k++)
          {
            try{
              if ((dis_list[k] != null)&& (dis_list[k].available()>0))
                {
                int len = dis_list[k].readInt();
                byte []buffer = new byte[len];    
                dis_list[k].read(buffer,0,len);
                String str = new String(buffer,0,len);
                System.out.println("I got len "+len+" msg: "+str);
                broadCast(str,k);
                String strLast = str.substring(str.lastIndexOf(':')+1);
                if (strLast.equalsIgnoreCase("exit"))
                {
                  nconnected--;
                  System.out.println("nconnected:"+nconnected);
                  
                  dis_list[k] = null;
                  socket_list[k].close();
                  if (nconnected == 0)
                    {
                      System.out.println("Exiting Server !!!");
                      ssock.close();
                      flag = false;
                      break;
                    }
                }
              }
            
            }catch(InterruptedIOException e){
                ;
            }catch(IOException e){
                ;
            }

          }
        
      }
    
  }





 
        /////////////////////////////////////////////////////////////////
       ////////Broatcasting the message to the all clients//////////////
       ////////////////////////////////////////////////////////////////


    public static void  broadCast(String s,int me)
      {
      for(int k=0;k<counter;k++)
       {
        try{
          if ((me != k)&&(dos_list[k] != null)){
            dos_list[k].writeInt(s.length());
            int sl = s.length();
            byte[] buf =new byte[sl];
            s.getBytes(0,sl,buf,0); 
            dos_list[k].write(buf,0,sl);
            System.out.println("We broadcast:"+s+ " client:"+k);
          }
        }catch(IOException e){
	  ;
         // System.out.println("IOException during bc ");
        }
      }
  }
}
 





///////////////////////////////////////////////////////////////////////
/////////////// CLASS FOR THE CLIENT//////////////////////////////////
/////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////
///////Defining the variables.//////////////////////////////// 
///////////////////////////////////////////////////////////


class client 
{
  Socket socket=null;
  boolean flag=true;
     
  InputStream in=null; 
  OutputStream out=null; 
  DataOutputStream dout=null; 
  DataInputStream dis=null;
  String hostname=null;
  receiveBC bcread;
  String host;
  int port;
  int URLPort;
  
  ///////////////////////////////////////////////////////
  ////////// Initialinzing the client///////////////////
  /////////////////////////////////////////////////////

public client (int port_,String host_,int URLPort_)
   {
   
     Socket socket=null;
     boolean flag=true;
     port=port_;     
     host=host_;
     URLPort=URLPort_;
    }

  /////////////////////////////////////////////////////////////// 
  //////////Giving the name to the user.////////////////////////
  /////////////////////////////////////////////////////////////
 
public void Name(String s){
       hostname=s;
    }


  ////////////////////////////////////////////////////////
  /////////// Make connection to the Server.///////////////
  //////////////////////////////////////////////////////


public void connect()
  {
       try{
       socket = new Socket(host,port);

       in = socket.getInputStream();
       out = socket.getOutputStream();
       dout = new DataOutputStream(out);
       dis = new DataInputStream(in);
     }catch(IOException e){
      ;
     }
     System.out.println("I connected "+dis+" "+dout);

     ////////////////////////////////////////////////////////////////////
     //////////////// Starts the server if it is not ready started.//////
     ///////////////////////////////////////////////////////////////////

      if ((dis==null)||(dout==null))
       {
        String command = "/cps606spring98-cgi/co98ham/runChatServer.pl";

        try{
          BufferedReader HTML = null;
          URL url = new URL("http",host,URLPort,command);
          url.openConnection().setUseCaches(false);
          HTML=new BufferedReader(new InputStreamReader(url.openStream()));
         }catch (MalformedURLException ev){
           System.out.println("URL error in (run) " + ev);
         }
         catch (IOException ev){
           System.out.println("IOException in (run)"+ev+" host "+host+" URLPort "+URLPort+" command "+command);
         }
         boolean flag=false;
         

	 /////////////////////////////////////////////////////////
	 //////////////////Make the connection.//////////////////
	 ///////////////////////////////////////////////////////

         while(flag == false){
           try{
             socket = new Socket(host,port);
             in = socket.getInputStream();
             out = socket.getOutputStream();
             dout = new DataOutputStream(out);
             dis = new DataInputStream(in);
             flag = true;
           }catch (IOException ev){
             ;//System.out.println("IOException in (run)"+ev);
           }
         }
         
         System.out.println("Started Chat Server ");
      }
          
 }
 
  ////////////////////////////////////////////////////////////
  /////////////Exits from server there is no client left/////
  //////////////////////////////////////////////////////////


public void exit()
  {
    try{
      socket.close();
     }catch(IOException e){
      ;
     }  
     
  }
  
  ///////////////////////////////////////////////////////////////////////
  ///////////////Submit the clients message to the server, and itself/// 
  /////////////////////////////////////////////////////////////////////

public void submit(String msg)
  {
    try{
      msg = hostname+":"+msg;
      dout.writeInt(msg.length());
      int sl = msg.length();
      byte[] buf =new byte[sl];
      msg.getBytes(0,sl,buf,0); 
      dout.write(buf,0,sl);
      System.out.println("I sent "+msg.length());
    }catch(IOException e){
      System.out.println("IOExcettion "+e);
    }  
  }
  
  

public void startNCThread(TextArea msgArea)
  {
    bcread = new receiveBC(dis,msgArea);
        
  }
}
 
////////////////////////////////////////////////////////////////
///////// Define a Thread to get all the message on time///////
//////////////////////////////////////////////////////////////

class receiveBC implements Runnable
{
  DataInputStream dis;
  Thread th;
  TextArea msgArea;
  
  
  public receiveBC(DataInputStream dis_,TextArea msgArea_)
  {
    dis = dis_;
    msgArea = msgArea_;
    th = new Thread(this);
    th.start();
    
  }

  //////////////////////////////////////////////////////
  //////////////////It gets message all the time.//////
  ////////////////////////////////////////////////////
 
  public void run()
  {
    boolean flag = true;
    
    while(flag){
       try{
           if (dis.available() >0  ){
             int len = dis.readInt();
             byte []buffer = new byte[len];       
             dis.read(buffer,0,len);
             String str = new String(buffer,0,len);
             System.out.println("I received len "+len+" msg: "+str);
             msgArea.append("\n"+str);
             
           }
           else
             th.yield();
                     
         }catch(IOException e){
           System.out.println("IO error during rece. bc ");
           flag = false;
           
         }
    }
  }
  
}


////////////////////////////////////////////////////////////////////
/////////////////Class Defining Chat Panel/////////////////////////
//////////////////////////////////////////////////////////////////



public class clientPANEL extends Applet

{
     String UName;
      boolean first=true;
  
 public void init()
   {

final client CLIENT = new client(2311,getCodeBase().getHost(),getCodeBase().getPort());
  


    Panel panel = new Panel();
    panel.setLayout(new BorderLayout(2,1));
    panel.setBackground(Color.pink);    
    
    final TextArea msgArea = new TextArea();
    panel.add(msgArea,BorderLayout.CENTER);

    
    Panel lowerArea = new Panel();
    lowerArea.setLayout(new BorderLayout());

    final TextField inputMsg = new TextField(60);
      
     inputMsg.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
           CLIENT.submit(inputMsg.getText());
           msgArea.append("\n"+inputMsg.getText());
           inputMsg.setText("");           
       }
    });
    
   
    lowerArea.add(inputMsg,BorderLayout.NORTH);

    Panel buttons = new Panel();
    buttons.setLayout(new GridLayout(1,5));

    Button quitButton = new Button("exit");
    quitButton.setBackground(Color.red); 
      quitButton.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
          CLIENT.submit("exit") ;
           CLIENT.exit() ;
       }
    });
    buttons.add(quitButton);
    
     final TextField name = new TextField(10);

      Label  label = new Label("typename");
      label.setBackground(Color.pink);
      Button NameButton=new Button("press");
      NameButton.setBackground(Color.red);
      NameButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {

       CLIENT.Name(name.getText());
    
	
	    }
    });

      ////////////////////////////////////////////////////
      //////////////Connect button///////////////////////
      ////////////////////////////////////////////////// 
    Button connectButton = new Button("connect");
    connectButton.setBackground(Color.green);
    connectButton.addActionListener(new ActionListener() {
      

       public void actionPerformed(ActionEvent e) {
           CLIENT.connect();
           CLIENT.startNCThread(msgArea) ;
       }
    });
    buttons.add(connectButton);
 

    /////////////////////////////////////////////////////////
    ///////Submit button////////////////////////////////////
    ///////////////////////////////////////////////////////

       Button submitButton = new Button("submit");
       submitButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
           CLIENT.submit(inputMsg.getText());
           msgArea.append("\n"+inputMsg.getText());
           inputMsg.setText("");
       }
    });
       ////////////////////////////////////////////////////
       /////////////Adding button to the panel.///////////
       //////////////////////////////////////////////////

    buttons.add(submitButton);   
    buttons.add(label);
    buttons.add(name);
    buttons.add(NameButton);
    
   lowerArea.add(buttons,BorderLayout.SOUTH);
 
    
   panel.add(lowerArea,BorderLayout.SOUTH);



    add(panel);
    show();
    
         }


     }



///The end of program.




  

